package vu.co.kaiyin;

import com.google.common.collect.BiMap;
import com.google.common.collect.HashBiMap;

/**
 * Created by IDEA on 16/03/15.
 */
public class GenoCodes {
    public static final BiMap<Byte, int[]> gencodeMap = gencodeMapGenerate();
    public static BiMap<Byte, int[]> gencodeMapGenerate() {
        BiMap<Byte, int[]> m = HashBiMap.create();

        m.put(new Byte((byte)0x00)    , new int[] {2, 2, 2, 2});
        m.put(new Byte((byte)0x01)    , new int[] {-9, 2, 2, 2});
        m.put(new Byte((byte)0x02)    , new int[] {1, 2, 2, 2});
        m.put(new Byte((byte)0x03)    , new int[] {0, 2, 2, 2});
        m.put(new Byte((byte)0x04)    , new int[] {2, -9, 2, 2});
        m.put(new Byte((byte)0x05)    , new int[] {-9, -9, 2, 2});
        m.put(new Byte((byte)0x06)    , new int[] {1, -9, 2, 2});
        m.put(new Byte((byte)0x07)    , new int[] {0, -9, 2, 2});
        m.put(new Byte((byte)0x08)    , new int[] {2, 1, 2, 2});
        m.put(new Byte((byte)0x09)    , new int[] {-9, 1, 2, 2});
        m.put(new Byte((byte)0x0a)    , new int[] {1, 1, 2, 2});
        m.put(new Byte((byte)0x0b)    , new int[] {0, 1, 2, 2});
        m.put(new Byte((byte)0x0c)    , new int[] {2, 0, 2, 2});
        m.put(new Byte((byte)0x0d)    , new int[] {-9, 0, 2, 2});
        m.put(new Byte((byte)0x0e)    , new int[] {1, 0, 2, 2});
        m.put(new Byte((byte)0x0f)    , new int[] {0, 0, 2, 2});
        m.put(new Byte((byte)0x10)   , new int[] {2, 2, -9, 2});
        m.put(new Byte((byte)0x11)   , new int[] {-9, 2, -9, 2});
        m.put(new Byte((byte)0x12)   , new int[] {1, 2, -9, 2});
        m.put(new Byte((byte)0x13)   , new int[] {0, 2, -9, 2});
        m.put(new Byte((byte)0x14)   , new int[] {2, -9, -9, 2});
        m.put(new Byte((byte)0x15)   , new int[] {-9, -9, -9, 2});
        m.put(new Byte((byte)0x16)   , new int[] {1, -9, -9, 2});
        m.put(new Byte((byte)0x17)   , new int[] {0, -9, -9, 2});
        m.put(new Byte((byte)0x18)   , new int[] {2, 1, -9, 2});
        m.put(new Byte((byte)0x19)   , new int[] {-9, 1, -9, 2});
        m.put(new Byte((byte)0x1a)   , new int[] {1, 1, -9, 2});
        m.put(new Byte((byte)0x1b)   , new int[] {0, 1, -9, 2});
        m.put(new Byte((byte)0x1c)   , new int[] {2, 0, -9, 2});
        m.put(new Byte((byte)0x1d)   , new int[] {-9, 0, -9, 2});
        m.put(new Byte((byte)0x1e)   , new int[] {1, 0, -9, 2});
        m.put(new Byte((byte)0x1f)   , new int[] {0, 0, -9, 2});
        m.put(new Byte((byte)0x20)   , new int[] {2, 2, 1, 2});
        m.put(new Byte((byte)0x21)   , new int[] {-9, 2, 1, 2});
        m.put(new Byte((byte)0x22)   , new int[] {1, 2, 1, 2});
        m.put(new Byte((byte)0x23)   , new int[] {0, 2, 1, 2});
        m.put(new Byte((byte)0x24)   , new int[] {2, -9, 1, 2});
        m.put(new Byte((byte)0x25)   , new int[] {-9, -9, 1, 2});
        m.put(new Byte((byte)0x26)   , new int[] {1, -9, 1, 2});
        m.put(new Byte((byte)0x27)   , new int[] {0, -9, 1, 2});
        m.put(new Byte((byte)0x28)   , new int[] {2, 1, 1, 2});
        m.put(new Byte((byte)0x29)   , new int[] {-9, 1, 1, 2});
        m.put(new Byte((byte)0x2a)   , new int[] {1, 1, 1, 2});
        m.put(new Byte((byte)0x2b)   , new int[] {0, 1, 1, 2});
        m.put(new Byte((byte)0x2c)   , new int[] {2, 0, 1, 2});
        m.put(new Byte((byte)0x2d)   , new int[] {-9, 0, 1, 2});
        m.put(new Byte((byte)0x2e)   , new int[] {1, 0, 1, 2});
        m.put(new Byte((byte)0x2f)   , new int[] {0, 0, 1, 2});
        m.put(new Byte((byte)0x30)   , new int[] {2, 2, 0, 2});
        m.put(new Byte((byte)0x31)   , new int[] {-9, 2, 0, 2});
        m.put(new Byte((byte)0x32)   , new int[] {1, 2, 0, 2});
        m.put(new Byte((byte)0x33)   , new int[] {0, 2, 0, 2});
        m.put(new Byte((byte)0x34)   , new int[] {2, -9, 0, 2});
        m.put(new Byte((byte)0x35)   , new int[] {-9, -9, 0, 2});
        m.put(new Byte((byte)0x36)   , new int[] {1, -9, 0, 2});
        m.put(new Byte((byte)0x37)   , new int[] {0, -9, 0, 2});
        m.put(new Byte((byte)0x38)   , new int[] {2, 1, 0, 2});
        m.put(new Byte((byte)0x39)   , new int[] {-9, 1, 0, 2});
        m.put(new Byte((byte)0x3a)   , new int[] {1, 1, 0, 2});
        m.put(new Byte((byte)0x3b)   , new int[] {0, 1, 0, 2});
        m.put(new Byte((byte)0x3c)   , new int[] {2, 0, 0, 2});
        m.put(new Byte((byte)0x3d)   , new int[] {-9, 0, 0, 2});
        m.put(new Byte((byte)0x3e)   , new int[] {1, 0, 0, 2});
        m.put(new Byte((byte)0x3f)   , new int[] {0, 0, 0, 2});
        m.put(new Byte((byte)0x40)   , new int[] {2, 2, 2, -9});
        m.put(new Byte((byte)0x41)   , new int[] {-9, 2, 2, -9});
        m.put(new Byte((byte)0x42)   , new int[] {1, 2, 2, -9});
        m.put(new Byte((byte)0x43)   , new int[] {0, 2, 2, -9});
        m.put(new Byte((byte)0x44)   , new int[] {2, -9, 2, -9});
        m.put(new Byte((byte)0x45)   , new int[] {-9, -9, 2, -9});
        m.put(new Byte((byte)0x46)   , new int[] {1, -9, 2, -9});
        m.put(new Byte((byte)0x47)   , new int[] {0, -9, 2, -9});
        m.put(new Byte((byte)0x48)   , new int[] {2, 1, 2, -9});
        m.put(new Byte((byte)0x49)   , new int[] {-9, 1, 2, -9});
        m.put(new Byte((byte)0x4a)   , new int[] {1, 1, 2, -9});
        m.put(new Byte((byte)0x4b)   , new int[] {0, 1, 2, -9});
        m.put(new Byte((byte)0x4c)   , new int[] {2, 0, 2, -9});
        m.put(new Byte((byte)0x4d)   , new int[] {-9, 0, 2, -9});
        m.put(new Byte((byte)0x4e)   , new int[] {1, 0, 2, -9});
        m.put(new Byte((byte)0x4f)   , new int[] {0, 0, 2, -9});
        m.put(new Byte((byte)0x50)   , new int[] {2, 2, -9, -9});
        m.put(new Byte((byte)0x51)   , new int[] {-9, 2, -9, -9});
        m.put(new Byte((byte)0x52)   , new int[] {1, 2, -9, -9});
        m.put(new Byte((byte)0x53)   , new int[] {0, 2, -9, -9});
        m.put(new Byte((byte)0x54)   , new int[] {2, -9, -9, -9});
        m.put(new Byte((byte)0x55)   , new int[] {-9, -9, -9, -9});
        m.put(new Byte((byte)0x56)   , new int[] {1, -9, -9, -9});
        m.put(new Byte((byte)0x57)   , new int[] {0, -9, -9, -9});
        m.put(new Byte((byte)0x58)   , new int[] {2, 1, -9, -9});
        m.put(new Byte((byte)0x59)   , new int[] {-9, 1, -9, -9});
        m.put(new Byte((byte)0x5a)   , new int[] {1, 1, -9, -9});
        m.put(new Byte((byte)0x5b)   , new int[] {0, 1, -9, -9});
        m.put(new Byte((byte)0x5c)   , new int[] {2, 0, -9, -9});
        m.put(new Byte((byte)0x5d)   , new int[] {-9, 0, -9, -9});
        m.put(new Byte((byte)0x5e)   , new int[] {1, 0, -9, -9});
        m.put(new Byte((byte)0x5f)   , new int[] {0, 0, -9, -9});
        m.put(new Byte((byte)0x60)   , new int[] {2, 2, 1, -9});
        m.put(new Byte((byte)0x61)   , new int[] {-9, 2, 1, -9});
        m.put(new Byte((byte)0x62)   , new int[] {1, 2, 1, -9});
        m.put(new Byte((byte)0x63)   , new int[] {0, 2, 1, -9});
        m.put(new Byte((byte)0x64)   , new int[] {2, -9, 1, -9});
        m.put(new Byte((byte)0x65)   , new int[] {-9, -9, 1, -9});
        m.put(new Byte((byte)0x66)   , new int[] {1, -9, 1, -9});
        m.put(new Byte((byte)0x67)   , new int[] {0, -9, 1, -9});
        m.put(new Byte((byte)0x68)   , new int[] {2, 1, 1, -9});
        m.put(new Byte((byte)0x69)   , new int[] {-9, 1, 1, -9});
        m.put(new Byte((byte)0x6a)   , new int[] {1, 1, 1, -9});
        m.put(new Byte((byte)0x6b)   , new int[] {0, 1, 1, -9});
        m.put(new Byte((byte)0x6c)   , new int[] {2, 0, 1, -9});
        m.put(new Byte((byte)0x6d)   , new int[] {-9, 0, 1, -9});
        m.put(new Byte((byte)0x6e)   , new int[] {1, 0, 1, -9});
        m.put(new Byte((byte)0x6f)   , new int[] {0, 0, 1, -9});
        m.put(new Byte((byte)0x70)   , new int[] {2, 2, 0, -9});
        m.put(new Byte((byte)0x71)   , new int[] {-9, 2, 0, -9});
        m.put(new Byte((byte)0x72)   , new int[] {1, 2, 0, -9});
        m.put(new Byte((byte)0x73)   , new int[] {0, 2, 0, -9});
        m.put(new Byte((byte)0x74)   , new int[] {2, -9, 0, -9});
        m.put(new Byte((byte)0x75)   , new int[] {-9, -9, 0, -9});
        m.put(new Byte((byte)0x76)   , new int[] {1, -9, 0, -9});
        m.put(new Byte((byte)0x77)   , new int[] {0, -9, 0, -9});
        m.put(new Byte((byte)0x78)   , new int[] {2, 1, 0, -9});
        m.put(new Byte((byte)0x79)   , new int[] {-9, 1, 0, -9});
        m.put(new Byte((byte)0x7a)   , new int[] {1, 1, 0, -9});
        m.put(new Byte((byte)0x7b)   , new int[] {0, 1, 0, -9});
        m.put(new Byte((byte)0x7c)   , new int[] {2, 0, 0, -9});
        m.put(new Byte((byte)0x7d)   , new int[] {-9, 0, 0, -9});
        m.put(new Byte((byte)0x7e)   , new int[] {1, 0, 0, -9});
        m.put(new Byte((byte)0x7f)   , new int[] {0, 0, 0, -9});
        m.put(new Byte((byte)0x80)   , new int[] {2, 2, 2, 1});
        m.put(new Byte((byte)0x81)   , new int[] {-9, 2, 2, 1});
        m.put(new Byte((byte)0x82)   , new int[] {1, 2, 2, 1});
        m.put(new Byte((byte)0x83)   , new int[] {0, 2, 2, 1});
        m.put(new Byte((byte)0x84)   , new int[] {2, -9, 2, 1});
        m.put(new Byte((byte)0x85)   , new int[] {-9, -9, 2, 1});
        m.put(new Byte((byte)0x86)   , new int[] {1, -9, 2, 1});
        m.put(new Byte((byte)0x87)   , new int[] {0, -9, 2, 1});
        m.put(new Byte((byte)0x88)   , new int[] {2, 1, 2, 1});
        m.put(new Byte((byte)0x89)   , new int[] {-9, 1, 2, 1});
        m.put(new Byte((byte)0x8a)   , new int[] {1, 1, 2, 1});
        m.put(new Byte((byte)0x8b)   , new int[] {0, 1, 2, 1});
        m.put(new Byte((byte)0x8c)   , new int[] {2, 0, 2, 1});
        m.put(new Byte((byte)0x8d)   , new int[] {-9, 0, 2, 1});
        m.put(new Byte((byte)0x8e)   , new int[] {1, 0, 2, 1});
        m.put(new Byte((byte)0x8f)   , new int[] {0, 0, 2, 1});
        m.put(new Byte((byte)0x90)   , new int[] {2, 2, -9, 1});
        m.put(new Byte((byte)0x91)   , new int[] {-9, 2, -9, 1});
        m.put(new Byte((byte)0x92)   , new int[] {1, 2, -9, 1});
        m.put(new Byte((byte)0x93)   , new int[] {0, 2, -9, 1});
        m.put(new Byte((byte)0x94)   , new int[] {2, -9, -9, 1});
        m.put(new Byte((byte)0x95)   , new int[] {-9, -9, -9, 1});
        m.put(new Byte((byte)0x96)   , new int[] {1, -9, -9, 1});
        m.put(new Byte((byte)0x97)   , new int[] {0, -9, -9, 1});
        m.put(new Byte((byte)0x98)   , new int[] {2, 1, -9, 1});
        m.put(new Byte((byte)0x99)   , new int[] {-9, 1, -9, 1});
        m.put(new Byte((byte)0x9a)   , new int[] {1, 1, -9, 1});
        m.put(new Byte((byte)0x9b)   , new int[] {0, 1, -9, 1});
        m.put(new Byte((byte)0x9c)   , new int[] {2, 0, -9, 1});
        m.put(new Byte((byte)0x9d)   , new int[] {-9, 0, -9, 1});
        m.put(new Byte((byte)0x9e)   , new int[] {1, 0, -9, 1});
        m.put(new Byte((byte)0x9f)   , new int[] {0, 0, -9, 1});
        m.put(new Byte((byte)0xa0)   , new int[] {2, 2, 1, 1});
        m.put(new Byte((byte)0xa1)   , new int[] {-9, 2, 1, 1});
        m.put(new Byte((byte)0xa2)   , new int[] {1, 2, 1, 1});
        m.put(new Byte((byte)0xa3)   , new int[] {0, 2, 1, 1});
        m.put(new Byte((byte)0xa4)   , new int[] {2, -9, 1, 1});
        m.put(new Byte((byte)0xa5)   , new int[] {-9, -9, 1, 1});
        m.put(new Byte((byte)0xa6)   , new int[] {1, -9, 1, 1});
        m.put(new Byte((byte)0xa7)   , new int[] {0, -9, 1, 1});
        m.put(new Byte((byte)0xa8)   , new int[] {2, 1, 1, 1});
        m.put(new Byte((byte)0xa9)   , new int[] {-9, 1, 1, 1});
        m.put(new Byte((byte)0xaa)   , new int[] {1, 1, 1, 1});
        m.put(new Byte((byte)0xab)   , new int[] {0, 1, 1, 1});
        m.put(new Byte((byte)0xac)   , new int[] {2, 0, 1, 1});
        m.put(new Byte((byte)0xad)   , new int[] {-9, 0, 1, 1});
        m.put(new Byte((byte)0xae)   , new int[] {1, 0, 1, 1});
        m.put(new Byte((byte)0xaf)   , new int[] {0, 0, 1, 1});
        m.put(new Byte((byte)0xb0)   , new int[] {2, 2, 0, 1});
        m.put(new Byte((byte)0xb1)   , new int[] {-9, 2, 0, 1});
        m.put(new Byte((byte)0xb2)   , new int[] {1, 2, 0, 1});
        m.put(new Byte((byte)0xb3)   , new int[] {0, 2, 0, 1});
        m.put(new Byte((byte)0xb4)   , new int[] {2, -9, 0, 1});
        m.put(new Byte((byte)0xb5)   , new int[] {-9, -9, 0, 1});
        m.put(new Byte((byte)0xb6)   , new int[] {1, -9, 0, 1});
        m.put(new Byte((byte)0xb7)   , new int[] {0, -9, 0, 1});
        m.put(new Byte((byte)0xb8)   , new int[] {2, 1, 0, 1});
        m.put(new Byte((byte)0xb9)   , new int[] {-9, 1, 0, 1});
        m.put(new Byte((byte)0xba)   , new int[] {1, 1, 0, 1});
        m.put(new Byte((byte)0xbb)   , new int[] {0, 1, 0, 1});
        m.put(new Byte((byte)0xbc)   , new int[] {2, 0, 0, 1});
        m.put(new Byte((byte)0xbd)   , new int[] {-9, 0, 0, 1});
        m.put(new Byte((byte)0xbe)   , new int[] {1, 0, 0, 1});
        m.put(new Byte((byte)0xbf)   , new int[] {0, 0, 0, 1});
        m.put(new Byte((byte)0xc0)   , new int[] {2, 2, 2, 0});
        m.put(new Byte((byte)0xc1)   , new int[] {-9, 2, 2, 0});
        m.put(new Byte((byte)0xc2)   , new int[] {1, 2, 2, 0});
        m.put(new Byte((byte)0xc3)   , new int[] {0, 2, 2, 0});
        m.put(new Byte((byte)0xc4)   , new int[] {2, -9, 2, 0});
        m.put(new Byte((byte)0xc5)   , new int[] {-9, -9, 2, 0});
        m.put(new Byte((byte)0xc6)   , new int[] {1, -9, 2, 0});
        m.put(new Byte((byte)0xc7)   , new int[] {0, -9, 2, 0});
        m.put(new Byte((byte)0xc8)   , new int[] {2, 1, 2, 0});
        m.put(new Byte((byte)0xc9)   , new int[] {-9, 1, 2, 0});
        m.put(new Byte((byte)0xca)   , new int[] {1, 1, 2, 0});
        m.put(new Byte((byte)0xcb)   , new int[] {0, 1, 2, 0});
        m.put(new Byte((byte)0xcc)   , new int[] {2, 0, 2, 0});
        m.put(new Byte((byte)0xcd)   , new int[] {-9, 0, 2, 0});
        m.put(new Byte((byte)0xce)   , new int[] {1, 0, 2, 0});
        m.put(new Byte((byte)0xcf)   , new int[] {0, 0, 2, 0});
        m.put(new Byte((byte)0xd0)   , new int[] {2, 2, -9, 0});
        m.put(new Byte((byte)0xd1)   , new int[] {-9, 2, -9, 0});
        m.put(new Byte((byte)0xd2)   , new int[] {1, 2, -9, 0});
        m.put(new Byte((byte)0xd3)   , new int[] {0, 2, -9, 0});
        m.put(new Byte((byte)0xd4)   , new int[] {2, -9, -9, 0});
        m.put(new Byte((byte)0xd5)   , new int[] {-9, -9, -9, 0});
        m.put(new Byte((byte)0xd6)   , new int[] {1, -9, -9, 0});
        m.put(new Byte((byte)0xd7)   , new int[] {0, -9, -9, 0});
        m.put(new Byte((byte)0xd8)   , new int[] {2, 1, -9, 0});
        m.put(new Byte((byte)0xd9)   , new int[] {-9, 1, -9, 0});
        m.put(new Byte((byte)0xda)   , new int[] {1, 1, -9, 0});
        m.put(new Byte((byte)0xdb)   , new int[] {0, 1, -9, 0});
        m.put(new Byte((byte)0xdc)   , new int[] {2, 0, -9, 0});
        m.put(new Byte((byte)0xdd)   , new int[] {-9, 0, -9, 0});
        m.put(new Byte((byte)0xde)   , new int[] {1, 0, -9, 0});
        m.put(new Byte((byte)0xdf)   , new int[] {0, 0, -9, 0});
        m.put(new Byte((byte)0xe0)   , new int[] {2, 2, 1, 0});
        m.put(new Byte((byte)0xe1)   , new int[] {-9, 2, 1, 0});
        m.put(new Byte((byte)0xe2)   , new int[] {1, 2, 1, 0});
        m.put(new Byte((byte)0xe3)   , new int[] {0, 2, 1, 0});
        m.put(new Byte((byte)0xe4)   , new int[] {2, -9, 1, 0});
        m.put(new Byte((byte)0xe5)   , new int[] {-9, -9, 1, 0});
        m.put(new Byte((byte)0xe6)   , new int[] {1, -9, 1, 0});
        m.put(new Byte((byte)0xe7)   , new int[] {0, -9, 1, 0});
        m.put(new Byte((byte)0xe8)   , new int[] {2, 1, 1, 0});
        m.put(new Byte((byte)0xe9)   , new int[] {-9, 1, 1, 0});
        m.put(new Byte((byte)0xea)   , new int[] {1, 1, 1, 0});
        m.put(new Byte((byte)0xeb)   , new int[] {0, 1, 1, 0});
        m.put(new Byte((byte)0xec)   , new int[] {2, 0, 1, 0});
        m.put(new Byte((byte)0xed)   , new int[] {-9, 0, 1, 0});
        m.put(new Byte((byte)0xee)   , new int[] {1, 0, 1, 0});
        m.put(new Byte((byte)0xef)   , new int[] {0, 0, 1, 0});
        m.put(new Byte((byte)0xf0)   , new int[] {2, 2, 0, 0});
        m.put(new Byte((byte)0xf1)   , new int[] {-9, 2, 0, 0});
        m.put(new Byte((byte)0xf2)   , new int[] {1, 2, 0, 0});
        m.put(new Byte((byte)0xf3)   , new int[] {0, 2, 0, 0});
        m.put(new Byte((byte)0xf4)   , new int[] {2, -9, 0, 0});
        m.put(new Byte((byte)0xf5)   , new int[] {-9, -9, 0, 0});
        m.put(new Byte((byte)0xf6)   , new int[] {1, -9, 0, 0});
        m.put(new Byte((byte)0xf7)   , new int[] {0, -9, 0, 0});
        m.put(new Byte((byte)0xf8)   , new int[] {2, 1, 0, 0});
        m.put(new Byte((byte)0xf9)   , new int[] {-9, 1, 0, 0});
        m.put(new Byte((byte)0xfa)   , new int[] {1, 1, 0, 0});
        m.put(new Byte((byte)0xfb)   , new int[] {0, 1, 0, 0});
        m.put(new Byte((byte)0xfc)   , new int[] {2, 0, 0, 0});
        m.put(new Byte((byte)0xfd)   , new int[] {-9, 0, 0, 0});
        m.put(new Byte((byte)0xfe)   , new int[] {1, 0, 0, 0});
        m.put(new Byte((byte)0xff)   , new int[] {0, 0, 0, 0});

        return m;
    }
}
